Program PixMapEd;

{$I-}

Uses
	Pix2Main,Pix2Mous,Pix2Text,Pix2Map,Pix2Gui,Crt;

Var
	M:PixTileMap;
	X,Y:Integer;

Procedure DrawMap;
Begin
	PixHideMouse;
	PixSetClip(0,0,149,179);
   M.Draw(X*M.TWd,Y*M.THg);
   PixWriteS(1,1,15,8,PixIntToStr(X)+','+PixIntToStr(Y));
   PixSetClip(0,0,319,199);
   PixShowMouse;
End;

Var
	B1,B2,B3,B4,B5,B6,B7,B8,B9,CB:PixButton;
   CurT,CurCol1,CurCol2:Byte;
	RX1,RY1,RX2,RY2:Integer;
	Clip:Pointer;

Procedure DrawStuff;
Var
	X,Y:Integer;
Begin
	PixDrawPanel(150,0,319,179);
   PixDrawPanel(0,180,319,199);
	For Y:=0 To M.THg-1 Do
   	For X:=0 To M.TWd-1 Do
      	PixFilledBox(155+X*5,5+Y*5,155+(X+1)*5,5+(Y+1)*5,15,
			     Byte(Ptr(Seg(M.Tiles[CurT]^),Ofs(M.Tiles[CurT]^)+4+(Y*M.TWd)+X)^));
   PixBox(287,4,288+M.TWd,5+M.THg,15);
   PixPutImage(M.Tiles[CurT],288,5,False);
   PixWriteS(155,161,15,8,'Map: '+PixIntToStr(M.MWd)+'x'+PixIntToStr(M.MWd));
   PixWriteS(200,161,15,8,'Tiles: '+PixIntToStr(M.TWd)+'x'+PixIntToStr(M.TWd));
   PixWriteS(175,170,15,8,'Tile '+PixIntToStr(CurT));
	PixFilledBox(155,150,230,158,15,CurCol1);
   PixFilledBox(235,150,310,158,15,CurCol2);
   B1.Draw;
   B2.Draw;
   B3.Draw;
   B5.Draw;
   B6.Draw;
   B7.Draw;
	B8.Draw;
	B9.Draw;
End;

Procedure PutSquare(X,Y:Integer;C:Byte);
Begin
   PixHideMouse;
	PixFilledBox(RX1+(X*5)+1,RY1+(Y*5)+1,RX1+((X+1)*5)-1,RY1+((Y+1)*5)-1,C,C);
   PixPutPixel(288+X,5+Y,C);
   PixShowMouse;
   Byte(Ptr(Seg(M.Tiles[CurT]^),Ofs(M.Tiles[CurT]^)+4+(Y*M.TWd)+X)^):=C;
   PixPutImage(M.Tiles[CurT],288,5,False);
End;

Function GetSquare(X,Y:Integer):Byte;
Begin
   GetSquare:=Byte(Ptr(Seg(M.Tiles[CurT]^),Ofs(M.Tiles[CurT]^)+4+(Y*M.TWd)+X)^);
End;

Procedure Run;
Var
	Quit:Boolean;
   Changed:Boolean;
   C,cX,cY:Integer;
Begin
   PixLoadCursor('ARROW',0,0);
   B1.Init(5,184,35,12,'Quit');
   B2.Init(155,169,15,8,'-');
   B3.Init(205,169,15,8,'+');
	B4.Init(155,150,155,9,'');
   B5.Init(45,184,40,12,'New tile');
	B6.Init(230,169,35,8,'Fill');
	B7.Init(90,184,35,12,'Save');
	B8.Init(270,169,15,8,'C');
	B9.Init(290,169,15,8,'P');
	CB.Init(75,120,35,12,'Ok');

   CurT:=0;
   CurCol1:=1;
   CurCol2:=0;
   X:=0;
   Y:=0;
	DrawMap;
   DrawStuff;
   PixShowMouse;
   Quit:=False;
   RX1:=155;
   RY1:=5;
	RX2:=155+M.TWd*5;
   RY2:=5+M.THg*5;
   Repeat
      PixMouseIdle;
      Changed:=False;
		If (MouseX=0) And (X>0) Then
      Begin
      	Dec(X);
         Changed:=True;
      End;
      If (MouseY=0) And (Y>0) Then
      Begin
      	Dec(Y);
         Changed:=True;
      End;
      If (MouseX=319) And (X<(M.MWd*M.TWd-150)Div M.TWd) Then
      Begin
      	Inc(X);
         Changed:=True;
		End;
      If (MouseY=199) And (Y<(M.MHg*M.THg-180)Div M.THg) Then
      Begin
      	Inc(Y);
         Changed:=True;
		End;
		If Changed Then
      Begin
      	DrawMap;
         Delay(50);
      End;
      Changed:=False;
      If (MouseX<150) And (MouseY<180) And MouseB1 Then
      Begin
      	If M.Map[(MouseX Div M.TWd)+X,(MouseY Div M.THg)+Y]<>CurT Then
         Begin
      		M.Map[(MouseX Div M.TWd)+X,(MouseY Div M.THg)+Y]:=CurT;
            DrawMap;
         End;
		End;
      If (MouseX<150) And (MouseY<180) And MouseB2 Then
      Begin
      	If M.Map[(MouseX Div M.TWd)+X,(MouseY Div M.THg)+Y]<>0 Then
         Begin
				M.Map[(MouseX Div M.TWd)+X,(MouseY Div M.THg)+Y]:=0;
            DrawMap;
         End;
      End;
      If (MouseX>RX1) And (MouseY>RY1) And (MouseX<RX2) And (MouseY<RY2) Then
      Begin
         If MouseB1 And (Not MouseB2) Then
				If (MouseX-RX1) Mod 5 >0 Then
		      Begin
               If GetSquare((MouseX-RX1) Div 5,(MouseY-RY1) Div 5)<>CurCol1 Then
               Begin
	            	PutSquare((MouseX-RX1) Div 5,(MouseY-RY1) Div 5,CurCol1);
	               Changed:=True;
            	End;
				End;
         If MouseB2 And (Not MouseB1) Then
		      If (MouseX-RX1) Mod 5 >0 Then
		      Begin
               If GetSquare((MouseX-RX1) Div 5,(MouseY-RY1) Div 5)<>CurCol2 Then
					Begin
	            	PutSquare((MouseX-RX1) Div 5,(MouseY-RY1) Div 5,CurCol2);
	               Changed:=True;
            	End;
         	End;
         If MouseB1 And MouseB2 Then
		      If (MouseX-RX1) Mod 5 >0 Then
				Begin
               If GetSquare((MouseX-RX1) Div 5,(MouseY-RY1) Div 5)<>0 Then
               Begin
	            	PutSquare((MouseX-RX1) Div 5,(MouseY-RY1) Div 5,0);
	               Changed:=True;
            	End;
         	End;
		End;
      If Changed Then
      Begin
      	DrawMap;
         Changed:=False;
		End;
		If B1.Idle Then Begin PixHideMouse; B1.Draw; PixShowMouse; End;
		If B2.Idle Then Begin PixHideMouse; B2.Draw; PixShowMouse; End;
		If B3.Idle Then Begin PixHideMouse; B3.Draw; PixShowMouse; End;
		If B5.Idle Then Begin PixHideMouse; B5.Draw; PixShowMouse; End;
		If B6.Idle Then Begin PixHideMouse; B6.Draw; PixShowMouse; End;
		If B7.Idle Then Begin PixHideMouse; B7.Draw; PixShowMouse; End;
		If B8.Idle Then Begin PixHideMouse; B8.Draw; PixShowMouse; End;
		If B9.Idle Then Begin PixHideMouse; B9.Draw; PixShowMouse; End;

		If B1.Check Then
      	Quit:=True;
      If B2.Check And (CurT>0) Then
      Begin
			Dec(CurT);
         PixHideMouse;
         DrawStuff;
         PixShowMouse;
      End;
      If B3.Check And (CurT<M.NumTil-1) Then
      Begin
			Inc(CurT);
         PixHideMouse;
         DrawStuff;
         PixShowMouse;
      End;
      B4.Idle;
      If B4.Check Then
      Begin
      	PixHideMouse;
			PixSetClip(0,0,149,179);
			For C:=1 To 120 Do
         Begin
				PixDrawPanel(150-C,C-120,150-C+119,C);
         End;
         C:=0;
         For cX:=0 To 15 Do
         	For cY:=0 To 15 Do
            Begin
            	PixFilledBox(35+cX*7,5+cY*7,35+cX*7+5,5+cY*7+5,C,C);
               Inc(C);
            End;
         PixBox(35+(CurCol1 Div 16)*7-1,5+(CurCol1 Mod 16)*7-1,35+(CurCol1 Div 16)*7+7-1,5+(CurCol1 Mod 16)*7+7-1,15);
         PixBox(35+(CurCol2 Div 16)*7-1,5+(CurCol2 Mod 16)*7-1,35+(CurCol2 Div 16)*7+7-1,5+(CurCol2 Mod 16)*7+7-1,14);
			PixSetClip(0,0,319,199);
         CB.Draw;
         PixShowMouse;
         Repeat
            PixMouseIdle;
            If CB.Idle Then
				Begin
            	PixHideMouse;
					CB.Draw;
               PixShowMouse;
            End;
         	If MouseB1 Then
            Begin
            	If (MouseX>=35) And (MouseY>=5) And (MouseX<=145) And (MouseY<=115) Then
               Begin
               	If ((MouseX-35) Mod 7<6) And ((MouseY-5) Mod 7<6) Then
                  Begin
                     PixHideMouse;
         				PixBox(35+(CurCol1 Div 16)*7-1,5+(CurCol1 Mod 16)*7-1,35+(CurCol1 Div 16)*7+7-1,5+(CurCol1 Mod 16)*7+7-1,197);
                  	CurCol1:=(((MouseX-35) Div 7)*16)+((MouseY-5) Div 7);
         				PixBox(35+(CurCol1 Div 16)*7-1,5+(CurCol1 Mod 16)*7-1,35+(CurCol1 Div 16)*7+7-1,5+(CurCol1 Mod 16)*7+7-1,15);
   						PixFilledBox(155,150,230,158,15,CurCol1);
                     PixShowMouse;
                  End;
               End;
				End;
         	If MouseB2 Then
				Begin
            	If (MouseX>=35) And (MouseY>=5) And (MouseX<=145) And (MouseY<=115) Then
               Begin
               	If ((MouseX-35) Mod 7<6) And ((MouseY-5) Mod 7<6) Then
                  Begin
                     PixHideMouse;
         				PixBox(35+(CurCol2 Div 16)*7-1,5+(CurCol2 Mod 16)*7-1,35+(CurCol2 Div 16)*7+7-1,5+(CurCol2 Mod 16)*7+7-1,197);
                  	CurCol2:=(((MouseX-35) Div 7)*16)+((MouseY-5) Div 7);
         				PixBox(35+(CurCol2 Div 16)*7-1,5+(CurCol2 Mod 16)*7-1,35+(CurCol2 Div 16)*7+7-1,5+(CurCol2 Mod 16)*7+7-1,14);
   						PixFilledBox(235,150,310,158,15,CurCol2);
                     PixShowMouse;
                  End;
               End;
            End;
         Until CB.Check;
         DrawMap;
         PixHideMouse;
			DrawStuff;
         PixShowMouse;
		End;
      If B5.Check Then
      Begin
      	If M.NumTil=256 Then
         	Write(#7)
         Else
         Begin
         	PixSelPage(1);
            PixFillPage(0);
            PixGetImage(M.Tiles[M.NumTil],0,0,M.TWd-1,M.THg-1,True);
            PixSelPage(0);
				CurT:=M.NumTil;
            Inc(M.NumTil);
         	PixHideMouse;
				DrawStuff;
				PixShowMouse;
			End;
		End;
		If B6.Check Then
		Begin
			For cY:=0 To M.THg-1 Do
				For cX:=0 To M.TWd-1 Do
				Begin
					PutSquare(cX,cY,CurCol1);
				End;
			PixHideMouse;
			DrawStuff;
			PixShowMouse;
			DrawMap;
		End;
		If B7.Check Then
		Begin
			M.Save(ParamStr(1));
		End;
		If B8.Check Then
		Begin
			Move(M.Tiles[CurT]^,Clip^,M.TWd*M.THg+4);
		End;
		If B9.Check Then
		Begin
			Move(Clip^,M.Tiles[CurT]^,M.TWd*M.THg+4);
			PixHideMouse;
			DrawStuff;
			PixShowMouse;
			DrawMap;
		End;
	Until Quit;
End;

Var
	F:File;
	W,H,sW,sH:Integer;
Begin
	WriteLn('Pix2MapEditor, Copyright(c) 1997, Jonathan Nicolas');
	WriteLn('Distributed freely with source ONLY WITH THE PIX GAME KERNEL!!!');
   WriteLn;
   If (ParamCount=0) Or (ParamCount>2) Then
	Begin
		WriteLn('Syntax: PIXMAPED <MAPFILE[.PTM]> [PALFILE[.PAL]]');
		WriteLn;
      Halt(0);
	End;
   If (ParamCount=2) Then
   Begin
   	Assign(F,ParamStr(2));
      Reset(F,1);
      If IOResult>0 Then
      Begin
         Assign(F,ParamStr(2)+'.PAL');
         Reset(F,1);
         If IOResult>0 Then
			Begin
	      	PixScreen('Unable to open palette file');
				WriteLn('File ',ParamStr(2),' doesn''t exist.');
				Halt(0);
			End;
		End;
		Close(F);
	End;
	W:=0;
	M.Init(0,0,200,180);
	Assign(F,ParamStr(1));
	Reset(F,1);
	If IOResult>0 Then
	Begin
		Assign(F,ParamStr(1)+'.PTM');
		Reset(F,1);
		If IOResult>0 Then
		Begin
			WriteLn('New map!!!');
			Write('Width> ');
			ReadLn(W);
			Write('Height> ');
			ReadLn(H);
			Write('Tile Width> ');
			ReadLn(sW);
			Write('Tile Height> ');
			ReadLn(sH);
			M.NewMap(W,H,sW,sH);
			If Not PixOpen(2) Then
			Begin
				PixScreen('Not enough memory');
				WriteLn('Please free up some memory before running this program.');
				Halt(0);
			End;
			PixGetImage(M.Tiles[0],0,0,M.TWd-1,M.THg-1,True);
			M.NumTil:=1;
		End
		Else
		Begin
			Close(F);
			M.Load(ParamStr(1));
		End;
	End
	Else
	Begin
		Close(F);
		M.Load(ParamStr(1));
	End;
	If W=0 Then
	Begin
		If Not PixOpen(2) Then
		Begin
			PixScreen('Not enough memory');
			WriteLn('Please free up some memory before running this program.');
			Halt(0);
		End;
	End;
	PixFillPage(0);
	If ParamCount=2 Then
	Begin
		PixLoadPalette(ParamStr(2),@PixPal);
		PixSetPalette(@PixPal);
	End;
	PixGetImage(Clip,0,0,M.TWd-1,M.THg-1,True);
	Run;
	PixClose;
	PixDeAllocImage(Clip);
End.